import { ApplicationRef, ModuleWithProviders, Type } from '@angular/core';
import { ReducerConfiguration, RootSlice, Scope, Slice, SliceOptions, TinySlicePlugin, TinySlicePluginHooks } from '@tinyslice/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class TinySliceAngularPlugin<State = unknown> implements TinySlicePlugin<State> {
    private readonly application;
    private hooks;
    private initialState;
    private sink;
    constructor(application: ApplicationRef);
    register: (hooks: TinySlicePluginHooks<State>) => void;
    onError: (error: unknown) => void;
    start: () => void;
    stop: () => void;
}
export declare class TinySliceModule {
    private readonly rootModuleIndicators;
    private readonly _effectServices;
    constructor(rootModuleIndicators: boolean[], _effectServices: Type<unknown>[]);
    static forRoot<RootState = unknown>(initialState: RootState, effectServices: Type<unknown>[], facade: new (slice: RootSlice<RootState>, scope: Scope) => unknown, storeOptions?: SliceOptions<never, RootState, unknown>): ModuleWithProviders<TinySliceModule>;
    /**
     * TODO: deal with nested features!
     */
    static forFeature<State>(key: string, initialState: State, reducers: ReducerConfiguration<State, any>[] | undefined, effectServices: Type<unknown>[], facade: new (slice: Slice<unknown, State>, scope: Scope) => unknown): ModuleWithProviders<TinySliceModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<TinySliceModule, [null, { optional: true; }]>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<TinySliceModule, never, [typeof i1.CommonModule], never>;
    static ɵinj: i0.ɵɵInjectorDeclaration<TinySliceModule>;
}
